/*
  Functions for 2D interpolation
  (c) Mircea Neacsu 2021
*/
#include <interp2/interp2.h>
#include <iostream>
#include <fstream>
#include <iomanip>

using namespace std;

typedef Matrix<double> data_2d;

ostream& operator <<(ostream& o, const data_2d& m)
{
  for (int i = 0; i < m.rows (); i++)
  {
    for (int j = 0; j < m.cols (); j++)
    {
      o << setw(8) << setprecision(4) << m (i, j);
//      if (j < m.rows () - 1)
//        o << ' ';
    }
    o << '\n';
  }
  return o;
}

int main (int argc, char** argv)
{
  data_2d v{
    {1, 2, 4, 1},
    {6, 3, 5, 2},
    {4, 2, 1, 5},
    {5, 4, 2, 3},
    {2, 3, 6, 4}
  };

  data_2d o1 (40, 30);
  nni (v, o1);
  cout << "Nearest neighbor interpolation:\n";
  cout << o1;
  ofstream out1 ("nni.prn");
  out1 << o1;

  data_2d o2 (40, 30);
  bilin (v, o2);
  cout << "Linear interpolation:\n";
  cout << o2;
  ofstream out2 ("bilin.prn");
  out2 << o2;

  data_2d o3 (40, 30);
  biquad (v, o3);
  cout << "Biquadratic interpolation:\n";
  cout << o3;
  ofstream out3 ("biquad.prn");
  out3 << o3;

  data_2d o4 (40, 30);
  bicube (v, o4);
  cout << "Bicubic interpolation:\n";
  cout << o4;
  ofstream out4 ("bicube.prn");
  out4 << o4;

  data_2d o5 (40, 30);
  cbi (v, o5);
  cout << "Constrained bicubic interpolation:\n";
  cout << o5;
  ofstream out5 ("cbi.prn");
  out5 << o5;

  return 0;
}
